using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using HySoft.Common;
using System.Data;

namespace HySoft.BaseCallCenter.Web.workordermanage.ajax
{
    /// <summary>
    /// WorkOrderStateAjax 的摘要说明
    /// </summary>
    public class WorkOrderStateAjax : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "text/plain";
            string action = CommonRequest.GetQueryString("action");
            switch (action)
            {
                case "getlist":
                    context.Response.Write(LoadList(context));
                    break;
                case "delete":
                    context.Response.Write(Delete(context));
                    break;
                //case "getstatelist":
                //    context.Response.Write(GetStateList(typeid == "" ? "-1" : typeid));
                //    break;
            }
        }

        #region 删除数据

        private string Delete(HttpContext context)
        {
            bool res = false;
            string arr = CommonRequest.GetQueryString("arrid");
            if (arr.IndexOf(",") == -1)
            {
                res = new BLL.T_Wo_WorkOrderState().Delete(Convert.ToInt32(arr));
            }
            else
            {
                res = new BLL.T_Wo_WorkOrderState().DeleteList(arr);
            }


            return res ? "success" : "field";
        }

        #endregion
        #region 获取数据
        private string LoadList(HttpContext context)
        {
            string res = "";
            DataTable dt = new DataTable();
            string sql = " ";

            try
            {
              

                string strpageindex = context.Request.Params["page"];
                int pageindex = 1;
                string strpagesize = context.Request.Params["pagesize"];
                int pagesize = 10;
                if (strpageindex.Trim() != "")
                {
                    try
                    {
                        pageindex = Convert.ToInt32(strpageindex);
                    }
                    catch
                    { }
                }

                if (strpagesize.Trim() != "")
                {
                    try
                    {
                        pagesize = Convert.ToInt32(strpagesize);
                    }
                    catch
                    { }
                }
                sql += CommonRequest.GetQueryString("whereSql")+" and F_Deleteflag=0";
                
                int recordCount = 0;

                Model.PageData<Model.T_Wo_WorkOrderState> pageModel = new Model.PageData<Model.T_Wo_WorkOrderState>();

                dt = BLL.PagerBLL.GetListPager(
                    "T_WO_WORKORDERSTATE",
                    "F_WorkOrderStateId",
                    "*",
                    sql,
                    "ORDER BY F_WorkOrderStateId desc",
                    pagesize,
                    pageindex,
                    true,
                    out recordCount);

                System.Collections.Generic.List<Model.T_Wo_WorkOrderState> modelList = new BLL.T_Wo_WorkOrderState().DataTableToList(dt);
                pageModel.Rows = modelList;
                pageModel.Total = recordCount;
                System.Runtime.Serialization.Json.DataContractJsonSerializer serializer = new System.Runtime.Serialization.Json.DataContractJsonSerializer(typeof(Model.PageData<Model.T_Wo_WorkOrderState>));

                using (System.IO.MemoryStream stream = new System.IO.MemoryStream())
                {
                    //JSON序列化
                    serializer.WriteObject(stream, pageModel);
                    res = System.Text.Encoding.UTF8.GetString(stream.ToArray());
                }
            }
            catch (Exception err)
            {
                //res = err.ToString(); 
            }
            finally
            {
                dt.Clear();
                dt.Dispose();
            }
            return res;
        }
        #endregion
        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}